# Copyright 2008, Chris Glasier

      def machineRb
      
       @dlg = UI::WebDialog.new("Machine", true, "Machine", 300, 205, 0, 0, false)
      
      @dlg.set_size 305,205
      
      subDir = "C:/Program Files/Google/Google SketchUp 7/Plugins/"
      fileName = "Machine.htm"
	
	@dlg.set_file File.join(File.dirname(__FILE__), subDir+fileName)
	
		
#makes geometry for regular objects like beams, columns and slabs
      
	@dlg.add_action_callback("drawer") {|d, p|

	model = Sketchup.active_model
	entities = model.entities
	group = entities.add_group
	entities = group.entities

	a= p.split(",")
		
	theX = Integer(a[0]).mm
	theY = Integer(a[1]).mm
	theZ = Integer(a[2]).mm
	
	point = Geom::Point3d.new theX, theY, theZ
	t = Geom::Transformation.new point
		
	#for faces
	theW	= Integer(a[3]).mm
	theD =  Integer(a[4]).mm
	theH = Integer(a[5]).mm
	
	pts = []
	pts[0] = [0, 0, 0]
	pts[1] = [theW, 0, 0]
	pts[2] = [theW, theD, 0]
	pts[3] = [0, theD, 0]
	
	base = entities.add_face pts
	
	height = -theH
	
	base.pushpull height

	group = group.move! t}
	
	
	@dlg.add_action_callback("mover") {|d, p|
	
	a = p.split(",")
	
	entityNo =  Integer(a[0])
	 theX = Integer(a[1]).mm
	theY = Integer(a[2]).mm
	theZ = Integer(a[3]).mm
			
	model = Sketchup.active_model
	entities = model.active_entities
	entity = entities[entityNo]
		
	point = Geom::Point3d.new theX, theY, theZ
	t = Geom::Transformation.new point
	
	entity.transform! t    }
	
		            
	@dlg.show()
      
       end 

	if (not file_loaded?("Machine.rb"))
    
	UI.menu("Plugins").add_item("Machine") { machineRb }
	
	end
	
	file_loaded("Machine.rb")   



      


      
    